# Practitioner $bulk-practitioner-update

`POST /Practitioner/$bulk-practitioner-update`

This resource includes details about an individual at a healthcare organization. The individual may range from those indirectly responsible for patient treatment or services (e.g., receptionists, IT personnel) to those directly responsible for patient treatment or services (e.g., physicians, pharmacists, therapists). However, this resource doesn’t include people related to the patient like a caregiver. 

You can review, retrieve, or update practitioner records in bulk.

> **Supported fields and schema examples**
>
> We support any valid FHIR field. However, we only display fields we’ve defined in our schema, which are usually based on what’s included in the U.S. Core profile. We recommend relying on U.S. Core requirements. 
>
> Our schema examples show the shape and possibility of each FHIR resource; they aren’t code for real-time API calls. We don’t currently recommend copying and pasting these schema examples for your API calls. [Consider reviewing FHIR API actions](/fhir-api-actions) for realistic examples for particular use cases.

### $bulk-practitioner-update

Update multiple providers at once. 

The structure of the payload is a `batch` bundle, and the RESTful operation in `entry.request.method` informs what type of operation should be be made on the resource. 

This operation is compatible with HL7v2 MFN style interfaces.

## Request body

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: Bundle |
| `type` | string | Yes | Indicates the purpose of this bundle - how it is intended to be used. Value: batch |
| `entry` | Array of Practitioner or PractitionerRole or Location or Other | Yes | An bundle of Practitioner, PractitionerRole and Location resources to be updated in bulk. |
| `entry[] (Practitioner).request` | object | No | Additional information about how this entry should be processed as part of a transaction or batch.  For history, it shows how the entry was processed to create the version contained in the entry. |
| `entry[] (Practitioner).request.method` | string | Yes | In a transaction or batch, this is the HTTP action to be executed for this entry. In a history bundle, this indicates the HTTP action that occurred. Possible values: GET, HEAD, POST, PUT, DELETE, PATCH |
| `entry[] (Practitioner).request.url` | string | Yes | The URL for this entry, relative to the root (the address to which the request is posted). |
| `entry[] (PractitionerRole).request` | object | No | Additional information about how this entry should be processed as part of a transaction or batch.  For history, it shows how the entry was processed to create the version contained in the entry. |
| `entry[] (PractitionerRole).request.method` | string | Yes | In a transaction or batch, this is the HTTP action to be executed for this entry. In a history bundle, this indicates the HTTP action that occurred. Possible values: GET, HEAD, POST, PUT, DELETE, PATCH |
| `entry[] (PractitionerRole).request.url` | string | Yes | The URL for this entry, relative to the root (the address to which the request is posted). |
| `entry[] (Location).request` | object | No | Additional information about how this entry should be processed as part of a transaction or batch.  For history, it shows how the entry was processed to create the version contained in the entry. |
| `entry[] (Location).request.method` | string | Yes | In a transaction or batch, this is the HTTP action to be executed for this entry. In a history bundle, this indicates the HTTP action that occurred. Possible values: GET, HEAD, POST, PUT, DELETE, PATCH |
| `entry[] (Location).request.url` | string | Yes | The URL for this entry, relative to the root (the address to which the request is posted). |
| `entry[] (Other).request` | object | No | Additional information about how this entry should be processed as part of a transaction or batch.  For history, it shows how the entry was processed to create the version contained in the entry. |
| `entry[] (Other).request.method` | string | Yes | In a transaction or batch, this is the HTTP action to be executed for this entry. In a history bundle, this indicates the HTTP action that occurred. Possible values: GET, HEAD, POST, PUT, DELETE, PATCH |
| `entry[] (Other).request.url` | string | Yes | The URL for this entry, relative to the root (the address to which the request is posted). |

## Request example

```bash
curl 'https://api.redoxengine.com/fhir/R4/{destinationSlug}/{environmentFlag}/Practitioner/$bulk-practitioner-update' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'Content-Type: application/fhir+json' \
--data '{
  "resourceType": "Bundle",
  "id": "BulkPractitionerUpdateExample",
  "type": "batch",
  "identifier": {
    "system": "urn:ietf:rfc:3986",
    "value": "urn:uuid:83de1e55-9475-48c4-a1c8-8e25e61d3227"
  },
  "timestamp": "2025-07-21T19:09:02.452Z",
  "entry": [
    {
      "resource": {
        "resourceType": "Practitioner",
        "id": "eb0d1d6a-41b9-5730-b5fd-f9142dc20961",
        "extension": [
          {
            "url": "http://synthetichealth.github.io/synthea/utilization-encounters-extension",
            "valueInteger": 507
          }
        ],
        "identifier": [
          {
            "system": "http://hl7.org/fhir/sid/us-npi",
            "value": "9999986992"
          }
        ],
        "active": true,
        "name": [
          {
            "family": "Wilderman",
            "given": [
              "Simonne"
            ],
            "prefix": [
              "Dr."
            ]
          }
        ],
        "telecom": [
          {
            "extension": [
              {
                "url": "http://hl7.org/fhir/us/core/StructureDefinition/us-core-direct",
                "valueBoolean": true
              }
            ],
            "system": "email",
            "value": "Simonne.Wilderman@example.com",
            "use": "work"
          }
        ],
        "address": [
          {
            "line": [
              "855 S MAIN ST"
            ],
            "city": "OCONTO FALLS",
            "state": "WI",
            "postalCode": "541541282",
            "country": "US"
          }
        ],
        "gender": "female"
      },
      "request": {
        "method": "POST",
        "url": "Practitioner"
      },
      "fullUrl": "urn:uuid:eb0d1d6a-41b9-5730-b5fd-f9142dc20961"
    },
    {
      "resource": {
        "resourceType": "Practitioner",
        "id": "a3a5a4c9-c8a1-5357-abfd-b7ae8688581f",
        "extension": [
          {
            "url": "http://synthetichealth.github.io/synthea/utilization-encounters-extension",
            "valueInteger": 250
          }
        ],
        "identifier": [
          {
            "system": "http://hl7.org/fhir/sid/us-npi",
            "value": "9999945790"
          }
        ],
        "active": true,
        "name": [
          {
            "family": "Bernhard",
            "given": [
              "Will"
            ],
            "prefix": [
              "Dr."
            ]
          }
        ],
        "telecom": [
          {
            "extension": [
              {
                "url": "http://hl7.org/fhir/us/core/StructureDefinition/us-core-direct",
                "valueBoolean": true
              }
            ],
            "system": "email",
            "value": "Will.Bernhard@example.com",
            "use": "work"
          }
        ],
        "address": [
          {
            "line": [
              "2745 W LAYTON AVE"
            ],
            "city": "MILWAUKEE",
            "state": "WI",
            "postalCode": "532212651",
            "country": "US"
          }
        ],
        "gender": "male"
      },
      "request": {
        "method": "DELETE",
        "url": "Practitioner/15159e73-b32d-36b2-b57b-e37a3041ace0"
      },
      "fullUrl": "urn:uuid:a3a5a4c9-c8a1-5357-abfd-b7ae8688581f"
    },
    {
      "resource": {
        "resourceType": "PractitionerRole",
        "id": "581d465d-0c4a-582e-b6a7-4ad61336a71a",
        "practitioner": {
          "identifier": {
            "system": "http://hl7.org/fhir/sid/us-npi",
            "value": "9999945790"
          },
          "display": "Dr. Will Bernhard"
        },
        "organization": {
          "reference": "Organization/8b124b8e-ce6a-3b8a-bf2c-b8f539a4e3ce",
          "identifier": {
            "system": "https://github.com/synthetichealth/synthea",
            "value": "8b124b8e-ce6a-3b8a-bf2c-b8f539a4e3ce"
          },
          "display": "AGELESS WELLNESS CENTER, INC"
        },
        "code": [
          {
            "coding": [
              {
                "code": "208D00000X",
                "system": "http://nucc.org/provider-taxonomy",
                "display": "General Practice Physician"
              }
            ],
            "text": "General Practice Physician"
          }
        ],
        "specialty": [
          {
            "coding": [
              {
                "code": "208D00000X",
                "system": "http://nucc.org/provider-taxonomy",
                "display": "General Practice Physician"
              }
            ],
            "text": "General Practice Physician"
          }
        ],
        "location": [
          {
            "reference": "Location/a5cc27d1-5c70-39f8-a9c4-2f3696988650",
            "identifier": {
              "system": "https://github.com/synthetichealth/synthea",
              "value": "a5cc27d1-5c70-39f8-a9c4-2f3696988650"
            },
            "display": "AGELESS WELLNESS CENTER, INC"
          }
        ],
        "telecom": [
          {
            "system": "phone",
            "value": "4144755800"
          },
          {
            "extension": [
              {
                "url": "http://hl7.org/fhir/us/core/StructureDefinition/us-core-direct",
                "valueBoolean": true
              }
            ],
            "system": "email",
            "value": "Will.Bernhard@example.com",
            "use": "work"
          }
        ]
      },
      "request": {
        "url": "PractitionerRole/999c23ff-e839-1b1b-7fa7-d22731b78207",
        "method": "POST"
      },
      "fullUrl": "urn:uuid:581d465d-0c4a-582e-b6a7-4ad61336a71a"
    },
    {
      "resource": {
        "resourceType": "PractitionerRole",
        "id": "17445836-639c-5c07-acac-27fa807ecce2",
        "practitioner": {
          "identifier": {
            "system": "http://hl7.org/fhir/sid/us-npi",
            "value": "9999986992"
          },
          "display": "Dr. Simonne Wilderman"
        },
        "organization": {
          "identifier": {
            "system": "https://github.com/synthetichealth/synthea",
            "value": "86336b7d-af6c-3f75-b2f5-7437732b471d"
          },
          "display": "HSHS ST CLARE MEMORIAL HOSPITAL"
        },
        "code": [
          {
            "coding": [
              {
                "code": "208D00000X",
                "system": "http://nucc.org/provider-taxonomy",
                "display": "General Practice Physician"
              }
            ],
            "text": "General Practice Physician"
          }
        ],
        "specialty": [
          {
            "coding": [
              {
                "code": "208D00000X",
                "system": "http://nucc.org/provider-taxonomy",
                "display": "General Practice Physician"
              }
            ],
            "text": "General Practice Physician"
          }
        ],
        "location": [
          {
            "identifier": {
              "system": "https://github.com/synthetichealth/synthea",
              "value": "1500ca21-bba4-32a9-8971-00bf404d259d"
            },
            "display": "HSHS ST CLARE MEMORIAL HOSPITAL"
          }
        ],
        "telecom": [
          {
            "system": "phone",
            "value": "9208463444"
          },
          {
            "extension": [
              {
                "url": "http://hl7.org/fhir/us/core/StructureDefinition/us-core-direct",
                "valueBoolean": true
              }
            ],
            "system": "email",
            "value": "Simonne.Wilderman@example.com",
            "use": "work"
          }
        ]
      },
      "request": {
        "url": "PractitionerRole/36ba349c-0d97-3fd2-c95f-b7eaa5924190",
        "method": "DELETE"
      },
      "fullUrl": "urn:uuid:17445836-639c-5c07-acac-27fa807ecce2"
    }
  ],
  "Meta": {
    "Logs": [
      {
        "ID": "d9f5d293-7110-461e-a875-3beb089e79f3",
        "AttemptID": "925d1617-2fe0-468c-a14c-f8c04b572c54"
      }
    ],
    "Test": true,
    "EventDateTime": "2026-11-20T22:18:53.621Z",
    "Source": {
      "ID": "7ce6f387-c33c-417d-8682-81e83628cbd9",
      "Name": "Redox Dev Tools"
    },
    "Destinations": [
      {
        "ID": "af394f14-b34a-464f-8d24-895f370af4c9",
        "Name": "Redox EMR"
      }
    ],
    "DataModel": "FHIR.Practitioner",
    "EventType": "$bulk-practitioner-update"
  }
}'
```

## Responses

### 200

Operation Response

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: OperationOutcome |
| `issue` | Array of object | Yes | A structured respresentation of the error that occurred |
| `issue[].severity` | string | Yes | Generally `error` or `fatal` Possible values: fatal, error, warning, information |
| `issue[].code` | string | Yes | A FHIR category code that describes the general type of issue. See http://hl7.org/fhir/ValueSet/issue-type for details |
| `issue[].id` | string | No | If the error occurs in the RedoxEngine, this corresponds to an Error record in the organization. |
| `issue[].details` | object | No | Additional details about the error. This may be a text description of the error or a system code that identifies the error. |
| `issue[].details.coding` | Array of object | No | A more granular FHIR code for the specific error. Typically from http://hl7.org/fhir/ValueSet/operation-outcome |
| `issue[].details.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `issue[].details.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `issue[].details.text` | string | No | A human-readable interpretation of the issue code |
| `issue[].diagnostics` | string | No | Additional diagnostic information about the issue. |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "id": "string",
      "severity": "fatal",
      "code": "string",
      "details": {
        "coding": [
          {
            "system": "string",
            "code": "string"
          }
        ],
        "text": "string"
      },
      "diagnostics": "string"
    }
  ]
}
```

### 400

Request could not be processed or failed validation

Same fields as 200.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "invalid",
      "details": {
        "coding": [
          {
            "code": "MSG_BAD_SYNTAX",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid content found in request body."
      }
    }
  ]
}
```

### 401

Authorization is required

Same fields as 200.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "unknown",
      "details": {
        "coding": [
          {
            "code": "MSG_AUTH_REQUIRED",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid authorization token"
      }
    }
  ]
}
```

### 500

Internal server error

Same fields as 200.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "processing",
      "details": {
        "coding": [
          {
            "code": "MSG_RESOURCE_ID_FAIL",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Unable to allocate resource id."
      }
    }
  ]
}
```

### 503

Service unavailable

Same fields as 200.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "transient",
      "details": {
        "text": "System is unable to process this message at this time."
      }
    }
  ]
}
```
